// #autoload
// #name = NewTimeHUD
// #version = 1.0
// #date = 14/12/2002
// #status = Release
// #author = Kaiten Commander
// #warrior = Kaiten Commander
// #email = kaiten@cb-tribes.co.uk
// #web = http://www.cb-tribes.co.uk
// #description = TimeHud with Game Time, System Time & Alarm
// #category = Kaiten
// #credit = UberGuy. For the time code.
// #config = NewTimeHudOptionsGui
// #readme = scripts/Kaiten/NewTimeHud.txt

if(isFile("prefs/NewTimeHudPrefs.cs"))
	exec("prefs/NewTimeHudPrefs.cs");
else
{	
        $NewTimeHudPref::AlarmEnabled = false;
        $NewTimeHudPref::AlarmMessage = "Enter Your Message Here.";
        $NewTimeHudPref::AlarmSoundEnabled = false;
        $NewTimeHudPref::AlarmTime = "12:00:00";
}


new AudioProfile(ringin)
{
	filename = "ringin.wav";
	description = "AudioGui";
	preload = true;
};

function makeNewTimeHud() {

	if (!isObject(NewTimeHud))
	{
		%x = getWord(hudClusterBack.position, 0)-26;
		%y = getWord(hudClusterBack.position, 1)+40;
		
		new HudScoreCtrl(NewTimeHud)
		{
			profile = "HudScoreProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = %x SPC %y;
			extent = "126 32";
			minExtent = "126 32";
			visible = "1";
		};
		
		new GuiTextCtrl(NewTimeHudLabel)
		{
			profile = "GuiTextObjGreenCenterProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "3 3";
			extent = "30 16";
			visible = "1";
			text = "Time:";
		};

		new GuiTextCtrl(NewTimeHudTime) {
			profile = "GuiTextObjGreenCenterProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "50 3";
			extent = "65 16 ";
			visible = "1";
		};
		
		new GuiTextCtrl(NewTimeHudMissionLable)
		{
			profile = "GuiTextObjCenterProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "3 22";
			extent = "30 16";
			visible = "1";
			text = "Game:";
		};
		
		new HudClock(GameClock)
		{
			profile = "GuiTextObjCenterProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "50 20";
			extent = "65 23";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			fillColor = "0.250000 0.250000 0.250000 0.250000";
			frameColor = "0.000000 1.000000 0.000000 1.000000";
			opacity = "0.9";
			bitmap = "gui/hud_mistimer.png";
			autoCenter = "0";
			autoResize = "0";
			flipVertical = "0";
			flipHorizontal = "0";
			subRegion = "0 2 65 15";
		};
		
		new GuiBitmapCtrl(AlarmStatusBitmap)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "110 3";
			extent = "10 10";
			bitmap = "gui/Kaiten/AlarmOff";
			opacity = "0.9";
			visible = "1";
		};
		
		NewTimeHud.add(NewTimeHudLabel);
		NewTimeHud.add(NewTimeHudTime);
		NewTimeHud.add(NewTimeHudMissionLable);
		NewTimeHud.add(GameClock);
		NewTimeHud.add(AlarmStatusBitmap);
		playGui.add(NewTimeHud);
		playgui.remove(clockhud);
		NewTimeHud.updateNewTimeHud();
	}
}

function NewTimeHud::updateNewTimeHud(%this)
{

	if (isEventPending(%this.schedID)) cancel(%this.schedID);
	%fmt = "HH:nn:ss";
	NewTimeHudTime.setText(formatTimeString(%fmt));
	if ($NewTimeHudPref::AlarmEnabled)
	{
        	if (formatTimeString(%fmt) $= $NewTimeHudPref::AlarmTime)
        	{
        		if ($NewTimeHudPref::AlarmSoundEnabled)
        			alxPlay( ringin, 0, 0, 0);
        		clientCmdBottomPrint($NewTimeHudPref::AlarmMessage @ "\nThe Time is:\n" @ $NewTimeHudPref::AlarmTime, 5, 3);	
        	}
	}
	%this.schedID = %this.schedule(1000,updateNewTimeHud);
}

package NewTimeHudPkg
{
	function LoadingGui::onWake(%this)
	{
		if (!$TimeHudCreate)
		{
			makeNewTimeHud();
					
			if (isObject(HudMover)) hudmover::addhud(NewTimeHud, "NewTimeHud");
		
			$TimeHudCreate = true;
		}
		parent::onWake(%this);
	}

	function clientCmdTogglePlayHuds(%val)
	{
		parent::clientCmdTogglePlayHuds(%val);
		NewTimeHud.setVisible(%val);
		if ($NewTimeHudPref::AlarmEnabled)
		{
		       	AlarmStatusBitmap.setBitmap("gui/Kaiten/AlarmOn");
		}	
		else
		{
			AlarmStatusBitmap.setBitmap("gui/Kaiten/AlarmOff");
        	}
	}

	function clientCmdSyncHudClock(%time)
	{
		GameClock.setTime(%time);
		parent::clientCmdSyncHudClock(%time);
	}

	function setSystemClock(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
	{
		$Hud::TimeLimit = detag(%a1);
		%timeLeftMS = detag(%a2);
		GameClock.setTime(%time = %timeLeftMS / (60 * 1000));
		
		parent::setSystemClock(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);
	}

};
activatePackage(NewTimeHudPkg);

function NewTimeHudOptionsGui::onWake(%this)
{
	UpdateNewTimeHudOptionsTime();
}

function NewTimeHudOptionsGui::onActivate(%this)
{
	UpdateNewTimeHudOptionsTime();
}

function NewTimeHudSavePrefs()
{
	export("$NewTimeHudPref::*", "prefs/NewTimeHudPrefs.cs", false);
	exec("prefs/NewTimeHudPrefs.cs");	
}

function UpdateNewTimeHudOptionsTime()
{
	%fmt = "HH:nn:ss";
	NewTimeHudOptionsCurrentTime.setText(formatTimeString(%fmt));
	if (NewTimeHudOptionsGui.visible $= "1" && Canvas.getContent() == ScriptBrowserGui.getID())
		schedule(1000, 0, UpdateNewTimeHudOptionsTime);
}

if (!isObject(NewTimeHudOptionsGui))
{
	new GuiControl(NewTimeHudOptionsGui) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 10";
		extent = "400 310";
		minExtent = "400 310";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "138 117";
			extent = "126 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$NewTimeHudPref::AlarmEnabled";
			helpTag = "0";
			text = "Alarm On";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "137 155";
			extent = "126 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$NewTimeHudPref::AlarmSoundEnabled";
			helpTag = "0";
			text = "Alarm Audible";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "DebriefHeadlineTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "101 9";
			extent = "188 32";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "New Time Hud Options";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl(NewTimeHudOptionsCurrentTime) {
			profile = "CenterPrintTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "220 195";
			extent = "104 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "12:00:00";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "CenterPrintTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "114 195";
			extent = "96 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Current Time:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl() {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "110 40";
			extent = "230 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$NewTimeHudPref::AlarmMessage";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "33 48";
			extent = "82 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Alarm Message:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl() {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "133 78";
			extent = "141 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$NewTimeHudPref::AlarmTime";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
		};
		new GuiTextCtrl() {
			profile = "ShellTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "67 88";
			extent = "61 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Alarm Time:";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellBitmapButton() {
                  	profile = "ShellButtonProfile";
                       	horizSizing = "right";
                       	vertSizing = "bottom";
                       	position = "155 255";
                       	extent = "100 38";
                       	minExtent = "32 38";
                       	visible = "1";
                       	hideCursor = "0";
                       	command = "NewTimeHudSavePrefs();";
                       	bypassHideCursor = "0";
                       	helpTag = "0";
                       	text = "SAVE";
                       	simpleStyle = "0";
               	};
	};
}